#line 1 "P:/_Electronique_/# LibStock #/1_wire_read_serial_number_and_temperature_ds18b20_or_ds18s20/OneWire.c"


sbit LCD_RS at LATB4_bit;
sbit LCD_EN at LATB5_bit;
sbit LCD_D4 at LATB0_bit;
sbit LCD_D5 at LATB1_bit;
sbit LCD_D6 at LATB2_bit;
sbit LCD_D7 at LATB3_bit;

sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D4_Direction at TRISB0_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB3_bit;





const unsigned short TEMP_RES_B = 12;
const unsigned short TEMP_RES_S = 9;
unsigned short TEMP_RESOLUTION;
unsigned temp;






char family_code;
char family_code_hex[2];

char *text = "000.0000";

char sernum[8];
char sernum_hex[2];
int i;
int colona;


void Resolution()
{
 Ow_Reset(&PORTE, 2);
 Ow_Write(&PORTE, 2, 0x33);
 Delay_us(120);

 family_code = Ow_Read(&PORTE, 2);

 switch( family_code )
 {
 case 0x28:
 TEMP_RESOLUTION = TEMP_RES_B;
 break;

 case 0x10:
 TEMP_RESOLUTION = TEMP_RES_S;
 break;

 case 0x01:
 TEMP_RESOLUTION = 0;
 break;

 case 0xFF:
 TEMP_RESOLUTION = 0;
 break;

 default:
 TEMP_RESOLUTION = 0;
 break;
 }


 Ow_Reset(&PORTE, 2);
 Ow_Write(&PORTE, 2, 0x33);
 Delay_us(120);

 for(i = 0; i <= 7; i++)
 {
 sernum[i] = Ow_Read(&PORTE, 2);
 }
}

void Read_Temperature()
{

 Ow_Reset(&PORTE, 2);
 Ow_Write(&PORTE, 2, 0xCC);
 Ow_Write(&PORTE, 2, 0x44);
 Delay_us(120);

 Ow_Reset(&PORTE, 2);
 Ow_Write(&PORTE, 2, 0xCC);
 Ow_Write(&PORTE, 2, 0xBE);

 temp = Ow_Read(&PORTE, 2);
 temp = (Ow_Read(&PORTE, 2) << 8) + temp;
}

void Display_SerialNumber()
{
 int i;
 colona = 17;

 for(i = 0; i <= 7; i++)
 {
 colona = colona - 2;
 ByteToHex(sernum[i], sernum_hex);
 Lcd_Out(1, colona, sernum_hex);
 }
}

void Display_Type()
{
 switch( family_code )
 {
 case 0x28:
 Lcd_Out(2, 1, "18B20");
 break;

 case 0x10:
 Lcd_Out(2, 1, "18S20");
 break;

 case 0x01:
 Lcd_Out(2, 1, "DS1990");
 break;

 case 0xFF:
 Lcd_Out(2, 1, "NoID  ");
 break;

 default:
 ByteToHex(family_code, family_code_hex);
 Lcd_Out(2, 1, family_code_hex );
 break;
 }
}

void Display_Temperature()
{
 unsigned short RES_SHIFT = TEMP_RESOLUTION - 8;
 char temp_whole;
 unsigned int temp2write;
 unsigned int temp_fraction;

 temp2write = temp;

 if (temp2write & 0x8000)
 {
 text[0] = '-';
 temp2write = ~temp2write + 1;
 }


 temp_whole = temp2write >> RES_SHIFT ;


 if (temp_whole/100)
 text[0] = temp_whole/100 + 48;
#line 164 "P:/_Electronique_/# LibStock #/1_wire_read_serial_number_and_temperature_ds18b20_or_ds18s20/OneWire.c"
 text[1] = (temp_whole/10)%10 + 48;
 text[2] = temp_whole%10 + 48;
 text[3] = '.';

 temp_fraction = temp2write << (4-RES_SHIFT);
 temp_fraction &= 0x000F;
 temp_fraction *= 625;


 text[4] = temp_fraction/1000 + 48;
 text[5] = (temp_fraction/100)%10 + 48;
 text[6] = (temp_fraction/10)%10 + 48;
 text[7] = temp_fraction%10 + 48;


 Lcd_Out(2, 7, text);


 Lcd_Chr_CP('\'');
 Lcd_Chr_CP('C');
}

void main()
{

 CMCON |=7;




 ADCON1 = 0x0D;

 PORTA = 0 ;
 TRISA = 0x03;

 TRISE.B2 = 1;

 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);


 do
 {
 Resolution();

 Display_SerialNumber();
 Display_Type();

 switch( family_code )
 {
 case 0x28:
 case 0x10:
 Read_Temperature();

 Display_Temperature();
 break;

 default:
 break;
 }

 Delay_ms(100);
 } while (1);
}
